<?php

// $Id$

/**
 * @file
 * RDFme module.
 * Author: Fernando Tapia Rico, Adam Westerski
 * File: rdfme.export.inc
 * Version: 1.6
 */

function rdfme_export_rdf_node($type, $node, $cid = '', $index = 0) {

  if (node_access('view',$node)) { //check if user has view access to node 
	  $node_array = _rdfme_get_node_array($type, $node, $cid, $index);
	  $namespaces = $node_array[0];
	  $classes = $node_array[1];
	  $properties = $node_array[2];
	  drupal_set_header('Content-Type: rdf/xml; charset: utf-8');
	  print('<?xml version="1.0" encoding="UTF-8"?>'."\n");
	  print('<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" ');
	  foreach ($namespaces as $namespace) {
	    $ns = db_query("SELECT * FROM {rdfme_namespaces} WHERE prefix = '%s'", $namespace);
	    if ($ns_object = db_fetch_object($ns)) {
	      print('  xmlns:' . $ns_object->prefix . '="' . $ns_object->uri . '"');
	    }
	  }
	  print('>' . "\n");
	  _rdfme_print_rdf($classes, $properties);
	  print('</rdf:RDF>' . "\n");
	  exit();
  }
  else
  { //if no access return empty rdf
	  drupal_set_header('Content-Type: rdf/xml; charset: utf-8');
	  print('<?xml version="1.0" encoding="UTF-8"?>'."\n");
	  print('<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" ');
	  print('>' . "\n");
//	  print('dupa: '.$node);
	  print('</rdf:RDF>' . "\n");
	  exit();
  }
}

function _rdfme_print_rdf($classes, $properties) {
  foreach ($classes as $class) {
    if (count($properties[$class[0]]) > 0) {
      $duplicate = FALSE;
      $output = array('');
      unset($org_key);//='';
      foreach ($properties[$class[0]] as $key => $field_property) {
      	
        if (count($field_property) == 1 || $duplicate || $class[0] == 0) {
          if ($duplicate && $class[0]!=0 && count($field_property)!=1 && (preg_match('/^(@@@'.$org_key.'_)+([0-9]+)+(@@@)/i',$key,$matches)>0)) //the case when a property is used few times in a single subclass
          { 
          	foreach ($field_property as $count => $f_property) {
            	$output[$count] .= _rdfme_property_string($classes, $class, $properties, $field_property, $key, $count);
          	}
          }
          else 
          {
          $exit = '';
          foreach ($field_property as $count => $f_property) {
            $exit .= _rdfme_property_string($classes, $class, $properties, $field_property, $key, $count);
          }
          foreach ($output as $count => $out) {
            $output[$count] .= $exit;
          }
          }
        }
        elseif ($duplicate == FALSE) {
          $org_key = $key;
          $duplicate = TRUE;
          $base_output = $output[0];
          $output = array();
          foreach ($field_property as $count => $property) {
            $output[] = $base_output . _rdfme_property_string($classes, $class, $properties, $field_property, $key, $count);
          }
        }
      }
      if ($duplicate) {
        $count = 1;
        foreach ($output as $out) {
          print('  <' . $class[1] . ' rdf:about="' . str_replace('/tordf', '/' . ($count) . '/tordf', $class[2]) . '">' . "\n");
          print($out);
          print('  </' . $class[1] . '>' . "\n");
          $count++;
        }
      }
      else {
        print('  <' . $class[1] . ' rdf:about="' . $class[2] . '">' . "\n");
        print($output[0]);
        print('  </' . $class[1] . '>' . "\n");
      }
    }
  }
}

function _rdfme_property_string($classes, $class, $properties, $field_property, $key, $index) {
  $exit = '';
  if ($field_property[$index][3] != $class[0]) {
    $base_uri = $classes[$field_property[$index][3]][2];
    if (count($properties[$field_property[$index][3]][$key]) == 1) {
      $exit = '    <' . $field_property[$index][0] . ' rdf:resource="' . $base_uri . '"/>' . "\n";
    }
    else {
      for ($x = 0; $x < count($properties[$field_property[$index][3]][$key]); $x++) {
        $exit .= '    <' . $field_property[$index][0] . ' rdf:resource="' . str_replace('/tordf', '/' . ($x + 1) . '/tordf', $base_uri) . '"/>' . "\n";
      }
    }
  }
  else {
    $exit = '    <' . $field_property[$index][0];
    $value = $field_property[$index][2];
    if ($field_property[$index][1] == 1) {
      $exit .= ' rdf:resource="' . $value . '"/>' . "\n";
    }
    else {
      $exit .= '>' . htmlspecialchars($value, ENT_NOQUOTES) . '</' . $field_property[$index][0] . '>' . "\n"; //$value
    }
  }
  return $exit;
}

function _rdfme_get_node_array($type, $node, $cid, $index) {
  $node = is_object($node) ? $node : node_load((int)$node);
  if ($cid != '') {
    $node = db_fetch_object(db_query(db_rewrite_sql("SELECT * FROM {comments} c WHERE c.cid = '%d'",'c'), $cid));
  }
  $classes = array();
  $properties = array();
  $namespaces = array();
  if ($index == 0) {
    $type_classes = db_query("SELECT * FROM {rdfme_content_types} WHERE type_name = '%s'", ($type == 'user' ? 'user':($cid != '' ? 'comment':($type == 'gallery_assist' ? 'gallery_assist':$node->type))));
    while ($type_class = db_fetch_object($type_classes)) {
      if ($type=='gallery_assist') //add pid to class info depending if node is gallery assist or not
      	$class_info = _rdfme_get_class($type_class->type_name, $type_class->class_index, $node->nid, $node->uid, $cid, $node->pid);
      else
      	$class_info = _rdfme_get_class($type_class->type_name, $type_class->class_index, $node->nid, $node->uid, $cid, 0);
      if ($class_info) {
        $ns = explode(':', $class_info[1]);
        if (!in_array($ns[0], $namespaces)) {
          $namespaces[] = $ns[0];
        }
        $classes[$type_class->class_index] = $class_info;
        $properties_info = _rdfme_get_properties($type_class->type_name, $type_class->class_index, $node, $namespaces);
        $properties[$type_class->class_index] = $properties_info[1];
        $namespaces = $properties_info[0];
      }
    }
  }
  else {
    $type_class = db_fetch_object(db_query("SELECT * FROM {rdfme_content_types} WHERE type_name = '%s' AND class_index = '%d'",
      ($type == 'user' ? 'user':($cid != '' ? 'comment':$node->type)),
      $index
    ));
    if ($type_class) {
      if ($type=='gallery_assist') //add pid to class info depending if node is gallery assist or not
      	$class_info = _rdfme_get_class($type_class->type_name, $index, $node->nid, $node->uid, $cid, $node->pid);
      else
      	$class_info = _rdfme_get_class($type_class->type_name, $index, $node->nid, $node->uid, $cid,0);
      if ($class_info) {
        $ns = explode(':', $class_info[1]);
        if (!in_array($ns[0], $namespaces)) {
          $namespaces[] = $ns[0];
        }
        $classes[$index] = $class_info;
        $properties_info = _rdfme_get_properties($type_class->type_name, $index, $node, $namespaces);
        $properties[$index] = $properties_info[1];
        $namespaces = $properties_info[0];
      }
    }
  }
  return array($namespaces, $classes, $properties);
}

function _rdfme_get_class($type, $index, $nid, $uid, $cid, $pid) {
  $class = db_fetch_object(db_query("SELECT * FROM {rdfme_content_types} WHERE type_name = '%s' AND class_index = '%d'", $type, $index));
  if ($class) {
    $uri = url(($type == 'user' ? 'user/' . $uid:'node/' . $nid . ($type == 'comment' ? '/' . $cid:'')) . ($index == 0 ? '':'/class/' . $index) . '/tordf', array('absolute' => TRUE));
    if ($class->uri) {
      $uri = $class->uri;
      $uri = str_replace('@@@nid@@@', $nid, $uri);
      $uri = str_replace('@@@uid@@@', $uid, $uri);
      $uri = str_replace('@@@cid@@@', $cid, $uri);
      $uri = str_replace('@@@pid@@@', $pid, $uri);
      $uri = str_replace('@@@id@@@', $index, $uri);
      $uri = str_replace('@@@url@@@', url('', array('absolute' => TRUE)), $uri);
    }
    return array($index, $class->class, $uri);
  }
  else {
    return FALSE;
  }
}

function _rdfme_get_properties($type, $index, $node, $namespaces) {
  $properties = array();
  $fields = db_query("SELECT * FROM {rdfme_fields} WHERE type_name = '%s' AND class_index = '%d'", $type, $index);
  //get all vocabularies info (used later for checking taxonomy mappings)
  $result = db_query("SELECT vid,name FROM {vocabulary}");
  $vocabularies = array();
  while ($vocabulary = db_fetch_object($result)) {
  	$vocabularies[$vocabulary->vid] = $vocabulary->name;
  }
  while ($field = db_fetch_object($fields)) {
    if ($field->is_property_of == 1) {
      $subclass = db_fetch_object(db_query("SELECT * FROM {rdfme_fields} WHERE type_name = '%s' AND class_index <> '0' AND field_name = '%s'", $type, $field->field_name));
      $properties[$field->field_name][] = array($field->property, 1, '', $subclass->class_index);
    }
    else {
      $value = array();
      if ($field->field_name == 'rdfme_literal_value') {
        $value[] = 'rdfme_literal_value';
      }
      elseif ($field->field_name == 'map_comment' && $type != 'comment' && $type != 'user') {
        $comments = db_query(db_rewrite_sql("SELECT * FROM {comments} c WHERE c.nid = '%d'",'c'), $node->nid);
        while ($comment = db_fetch_object($comments)) {
          $value[] = $comment->cid;
        }
      }
      elseif (strstr($field->field_name,'taxonomy_') && $type != 'comment' && $type != 'user') {
        if (is_array($node->taxonomy)) {
          foreach ($node->taxonomy as $topic) {
    		$string = $vocabularies[$topic->vid];
			$string    = htmlentities(strtolower($string));
	    	$string    = preg_replace("/&(.)(acute|cedil|circ|ring|tilde|uml);/", "$1", $string);
    		$string    = preg_replace("/([^a-z0-9]+)/", "_", html_entity_decode($string));
	    	$string    = trim($string, "_");
            if ('taxonomy_'.$string==$field->field_name)    
            //if ('taxonomy_'.$topic->vid==$field->field_name)    
            $value[] = $topic->name;
          }
        }
        else {
          $value[] = $node->taxonomy;
        }
      }
      elseif (strstr($field->field_name,'images_')) {
        if (is_array($node->images)) {
            if ('images_original'==$field->field_name)
            	$value[] = $node->images['_original'];
            elseif ('images_thumbnail'==$field->field_name)
            	$value[] = $node->images['thumbnail'];
            elseif ('images_preview'==$field->field_name)
            	$value[] = $node->images['preview'];
          }
      }
      elseif ($field->field_name == 'primary_topic' && $type != 'comment' && $type != 'user') {
        $source = db_fetch_object(db_query("SELECT * FROM {rdfme_primary_topic} WHERE nid = '%d'", $node->nid));
        $value[] = $source->primary_topic;
      }
      elseif ($field->field_name == 'workflow_state' && $type != 'comment' && $type != 'user') {
        $wf_node = db_fetch_object(db_query(db_rewrite_sql("SELECT * FROM {workflow_node} n WHERE n.nid = '%d'"), $node->nid));
        //$wf = db_query(db_rewrite_sql("SELECT * FROM {workflow_states} WHERE sid = '%d'"), $wf_node->sid);
        $wf = db_query("SELECT * FROM {workflow_states} WHERE sid = '%d'", $wf_node->sid);
        while ($state = db_fetch_object($wf)) {
          $value[] = $state->state;
        }
      }
      elseif (strncmp($field->field_name, 'opal_', 5) == 0 && $type != 'user') {
        if ($type == 'comment') {
    	    $opal = db_fetch_object(db_query("SELECT * FROM {opal_comments} WHERE cid = '%d'", $node->cid));
          //$opal = db_fetch_object(db_query(db_rewrite_sql("SELECT * FROM {opal_comments} WHERE cid = '%d'"), $node->cid));
          $value[] = number_format($opal->score, 4, '.', '');
        }
        else {
          $opal = db_fetch_object(db_query(db_rewrite_sql("SELECT * FROM {opal_nodes} n WHERE n.nid = '%d'"), $node->nid));
          $value[] = $opal->{str_replace('opal_', '', $field->field_name)};
        }
      }
      elseif (($field->field_name == 'image_module') && module_exists('image')) { //reference from node to image (image module)
    	  $images = db_query("SELECT * FROM image_attach WHERE image_attach.nid = '%d'", $node->nid);
	      while ($image = db_fetch_object($images)) {
          	$value[] = $image->iid;
          }
      }
      elseif (($field->field_name == 'image_parent') && module_exists('image')) { //reference from image to node (image module)
    	  $images = db_query("SELECT * FROM image_attach WHERE image_attach.iid = '%d'", $node->nid);
	      while ($image = db_fetch_object($images)) {
          	$value[] = $image->nid;
          }
      }
      elseif (($field->field_name == 'image_gallery_assist') && module_exists('gallery_assist')) { //reference from node to gallery (gallery_assist module)
    	  $images = db_query("SELECT * FROM gallery_assist_item WHERE nid = '%d'", $node->nid);
	      while ($image = db_fetch_object($images)) {
          	$value[] = $image->pid;
          }
      }
      elseif ($field->field_name == 'votingapi_rating') {
        $voting = db_query("SELECT * FROM {votingapi_vote} WHERE content_type = '%s' AND content_id = '%d'",
          (($type != 'user' && $type != 'comment') ? 'node':$type), (($type == 'user') ? $node->uid:($type == 'comment' ? $node->cid:$node->nid))
        );
        $rating = 0.0;
        $count = 0.0;
        $percent = FALSE;
        while ($vote = db_fetch_object($voting)) {
          if ($vote->value_type == 'percent') {
            $percent = TRUE;
          }
          $rating += $vote->value;
          $count += 1.0;
        }
        if ($percent) {
          $rating = $rating/(100*$count);
        }
        if ($rating == 0) $rating = '0'; //change rating to string so that is not interpreted as empty
        $value[] = $rating;
      }
      else {
        if ($type != 'user' && $type != 'comment') {
          $value = _rdfme_obtain_field_value($field->field_name, $node);
        }
        else {
          $variables = get_object_vars($node);
          if (is_array($variables[$field->field_name])) {
            foreach ($variables[$field->field_name] as $variable) {
              $value[] = $variable;
            }
          }
          else {
            $value[] = $variables[$field->field_name];
          }
        }
      }
      if (count($value) > 0) {
      	$field_name=$field->field_name;
      	if (strcmp($field->field_name,'rdfme_literal_value')!=0 && isset($properties[$field->field_name]) & $index!=0) //if property is used more than twice in child class (as in two field in subclass use the property name to transform it in different way)
		{
      		//$field_name=$field->field_name;
      		$field_name_index=0;
      		while (isset($properties[$field_name]))
      		{
      			$field_name_index++;
      			$field_name='@@@'.$field->field_name . '_' . $field_name_index.'@@@';
      		}
      	}
      	
        foreach ($value as $property) {
          if ($property != '') {
            if ($field->pattern != '') {
              $property = _rdfme_change_markup($field->pattern, $property, $node->nid, $node->uid, $node->cid, $index);
            }
            $properties[$field_name][] = array($field->property, $field->is_resource, $property, $index); //$field->field_name
          }
        }
      }
    }
  }
  foreach ($properties as $field_property) {
    foreach ($field_property as $property) {
      $ns = explode(':', $property[0]);
      if (!in_array($ns[0], $namespaces)) {
        $namespaces[] = $ns[0];
      }
    }
  }
  //if ($type=='idea' && $index==1) var_dump($properties);
  return array($namespaces, $properties);
}

function _rdfme_change_markup($pattern, $value, $nid, $uid, $cid, $index) {
  $pattern = str_replace('@@@value@@@', $value, $pattern);
  $pattern = str_replace('@@@nid@@@', $nid, $pattern);
  $pattern = str_replace('@@@uid@@@', $uid, $pattern);
  $pattern = str_replace('@@@cid@@@', $cid, $pattern);
  $pattern = str_replace('@@@id@@@', $index, $pattern);
  $pattern = str_replace('@@@url@@@', url('', array('absolute' => TRUE)), $pattern);
  //translation tables
  $match=FALSE;
  if (strstr($pattern, '@@@translation.')) //if translation table pattern detected translate the value according to the table entry
  {
   $num= preg_match('/^(@@@translation\.)+(.+)+(@@@)/i',$pattern,$matches);      
   $table_name = $matches[2];
   $result = db_query("SELECT * FROM rdfme_translation_table_fields JOIN rdfme_translation_tables ON rdfme_translation_table_fields.table_id=rdfme_translation_tables.id WHERE rdfme_translation_tables.name='%s'",$table_name);
   while ($translation_rule = db_fetch_object($result)) {
    if (strstr($translation_rule->input_pattern, '@@@value@@@')) //if the input_pattern is not value but some rule
    {
    	$val_num= (float)$value; //convert value to a number
   		$num= preg_match('/^([0-9]+)?(<|>)?(@@@value@@@)?(<|>)?([0-9]+)?/i',$translation_rule->input_pattern,$matches);
   		$error=FALSE;
   		
   		if ($num==1) {
			switch ($matches[2]) {
			    case '<':
			        $floor=(float)$matches[1];
			        break;
			    case '>':
			        $ceil=(float)$matches[1];
			        break;
			}
   			
			switch ($matches[4]) {
			    case '<':
			        $ceil=(float)$matches[5];
			        break;
			    case '>':
			        $floor=(float)$matches[5];
			        break;
			}
   		}

   		if (isset($ceil))
   		{
	   		if ($val_num<$ceil && $val_num>$floor)
	   		{
	   			$ouput_pattern=_rdfme_change_markup_translation_output($translation_rule->output_pattern, $value, $nid, $uid, $cid, $index); //before inserting output check for patterns
	   			$pattern = str_replace('@@@translation.'.$table_name.'@@@', $ouput_pattern, $pattern);   		 
	   			$match=TRUE;
	   		}
   		} else
		{
	   		if ($val_num>$floor)
	   		{
	   			$ouput_pattern=_rdfme_change_markup_translation_output($translation_rule->output_pattern, $value, $nid, $uid, $cid, $index); //before inserting output check for patterns
	   			$pattern = str_replace('@@@translation.'.$table_name.'@@@', $ouput_pattern, $pattern);   		 
	   			$match=TRUE;
	   		}
		}   		
    } else //if the patern is a string value
    {
     if (strcmp($value,$translation_rule->input_pattern)==0) //if pattern maches value than substituite it with the output_pattern
     {
     	$ouput_pattern=_rdfme_change_markup_translation_output($translation_rule->output_pattern, $value, $nid, $uid, $cid, $index); //before inserting output check for patterns
     	$pattern = str_replace('@@@translation.'.$table_name.'@@@', $ouput_pattern, $pattern);
     	$match=TRUE;
     }
    }
   }
   if ($match!=TRUE) //if there was no match replace the pattern with value
   	$pattern = str_replace('@@@translation.'.$table_name.'@@@', $value, $pattern);
  }
  // end of translation table logic
  return $pattern;
}

function _rdfme_change_markup_translation_output($pattern, $value, $nid, $uid, $cid, $index) {
  $pattern = str_replace('@@@value@@@', $value, $pattern);
  $pattern = str_replace('@@@nid@@@', $nid, $pattern);
  $pattern = str_replace('@@@uid@@@', $uid, $pattern);
  $pattern = str_replace('@@@cid@@@', $cid, $pattern);
  $pattern = str_replace('@@@id@@@', $index, $pattern);
  $pattern = str_replace('@@@url@@@', url('', array('absolute' => TRUE)), $pattern);
  return $pattern;
}

function _rdfme_obtain_field_value($field, $node) {
  $field_object = db_fetch_object(db_query("SELECT * FROM {content_node_field} WHERE field_name = '%s'", $field));
  //$field_object = db_fetch_object(db_query(db_rewrite_sql("SELECT * FROM {content_node_field} WHERE field_name = '%s'"), $field));
  $variables = get_object_vars($node);
  $value = array();
  if ($field_object) {
    $key = 'value';
    switch ($field_object->type) {
      case 'nodereference' :
      case 'nodereferrer' :
        $key = 'nid';
        break;
      case 'userreference' :
        $key = 'uid';
        break;
      case 'computed' :
      case 'datestamp' :
      case 'number_float' :
      case 'number_integer' :
      case 'text' :
        $key = 'value';
        break;
      case 'link' :
        $value = 'url';
        break;
      case 'image' :
      case 'filefield' :
        $key = 'filepath';
        break;
    }
    
    if (is_array($variables[$field])) {
      foreach ($variables[$field] as $variable) {
        if ($key == 'nid') { 
        	if (node_access('view',$variable[$key])) $value[] = $variable[$key];
		} else
        $value[] = $variable[$key];
      }
    }
    else {
        if ($key == 'nid') { 
        	if (node_access('view',$variable[$key])) $value[] = $variable[$key];
		} else
      		$value[] = $variables[$field];
    }
  }
  else {
    if (is_array($variables[$field])) {
      foreach ($variables[$field] as $variable) {
        if ($key == 'nid') { 
        	if (node_access('view',$variable[$key])) $value[] = $variable[$key];
		} else
	        $value[] = $variable;
      }
    }
    else {
        if ($key == 'nid') { 
        	if (node_access('view',$variable[$key])) $value[] = $variable[$key];
		} else
	      $value[] = $variables[$field];
    }
  }
  return $value;
}

function rdfme_dump() {
  drupal_set_header('Content-Type: rdf/xml; charset: utf-8');
  $namespaces = db_query("SELECT * FROM {rdfme_namespaces}");
  print('<?xml version="1.0" encoding="UTF-8"?>'."\n");
  print('<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" ');
  while ($ns = db_fetch_object($namespaces)) {
    print('  xmlns:' . $ns->prefix . '="' . $ns->uri . '"');
  }
  print('>'."\n");
  $nodes = db_query(db_rewrite_sql("SELECT * FROM {node} n"));
  while ($node = db_fetch_object($nodes)) {
    $node_array = _rdfme_get_node_array('node', $node->nid, '', 0);
    $classes = $node_array[1];
    $properties = $node_array[2];
    _rdfme_print_rdf($classes, $properties);
  }
  $comments = db_query(db_rewrite_sql("SELECT * FROM {comments} c",'c'));
  while ($comment = db_fetch_object($comments)) {
    $node_array = _rdfme_get_node_array('node', $comment, $comment->cid, 0);
    $classes = $node_array[1];
    $properties = $node_array[2];
    _rdfme_print_rdf($classes, $properties);
  }
  $users = db_query("SELECT * FROM {users}");
  while ($user = db_fetch_object($users)) {
    $node_array = _rdfme_get_node_array('user', $user, '', 0);
    $classes = $node_array[1];
    $properties = $node_array[2];
    _rdfme_print_rdf($classes, $properties);
  }
  //special treatment for gallery_assist module (because galleries are not saved as nodes in the node table)
  if (module_exists('gallery_assist')) {
	  $gallery_assist_images = db_query("SELECT * FROM {gallery_assist_item} JOIN {gallery_assist_translated} ON gallery_assist_item.pid=gallery_assist_translated.pid");
	  while ($gallery_assist_image = db_fetch_object($gallery_assist_images)) {
	    $node_array = _rdfme_get_node_array('gallery_assist', $gallery_assist_image, '', 0);
	    $classes = $node_array[1];
	    $properties = $node_array[2];
	    _rdfme_print_rdf($classes, $properties);
	  }
  }
  print('</rdf:RDF>'."\n");
  exit();
}
